#include <iostream>
using namespace std;

int main() {
	int N;
	cin>> N;
	int q[N];
	
	for(int i=1;i<=N;i++){
		
		cin>>q[i];
		
	}
	
	int w;
	
	cin>>w;
	
	int p[w], k[w];
	
	for(int j=1; j<=w;j++){
		
		cin>>p[j]>>k[j];
		
	}
	
	for(int j=1;j<=w;j++){
		int y=0;
		
		for(int o=k[j];o>p[j];o--){
			
			for(int l=p[j];l<o;l++){
				
				if(q[o]<q[l]){
					y++;
				}
				
			}
			
			
		}
		if(y>2){
				cout<<"NE"<<endl;
				
			}
			else cout<<"DA"<<endl;
	}
	return 0;
}